JonasDeploymentTool (Apache Ant API)
Date: 2018-09-12

Package org.apache.tools.ant.taskdefs.optional.ejb

## Class JonasDeploymentTool

- java.lang.Object
- - org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool
  - - org.apache.tools.ant.taskdefs.optional.ejb.JonasDeploymentTool

- All Implemented Interfaces:
    `EJBDeploymentTool`

      public class JonasDeploymentTool
      extends GenericDeploymentTool

  The deployment tool to add the jonas specific deployment descriptors to the ejb JAR file. JONAS only requires one additional file jonas-ejb-jar.xml.
  Version:
    1.0
  See Also:
    `EjbJar.createJonas()`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected static java.lang.String` | `DAVID_ORB` | DAVID ORB.
    `protected static java.lang.String` | `EJB_JAR_1_1_DTD` | Name of the standard deployment descriptor DTD (these files are stored in the ${JONAS_ROOT}/xml directory).
    `protected static java.lang.String` | `EJB_JAR_1_1_PUBLIC_ID` | Public Id of the standard deployment descriptor DTD.
    `protected static java.lang.String` | `EJB_JAR_2_0_DTD` |
    `protected static java.lang.String` | `EJB_JAR_2_0_PUBLIC_ID` |
    `protected static java.lang.String` | `GENIC_CLASS` | GenIC class name (JOnAS 2.5)
    `protected static java.lang.String` | `JEREMIE_ORB` | JEREMIE ORB.
    `protected static java.lang.String` | `JONAS_DD` | Default JOnAS deployment descriptor name.
    `protected static java.lang.String` | `JONAS_EJB_JAR_2_4_DTD` | Name of the JOnAS-specific deployment descriptor DTD (these files are stored in the ${JONAS_ROOT}/xml directory).
    `protected static java.lang.String` | `JONAS_EJB_JAR_2_4_PUBLIC_ID` | Public Id of the JOnAS-specific deployment descriptor DTD.
    `protected static java.lang.String` | `JONAS_EJB_JAR_2_5_DTD` |
    `protected static java.lang.String` | `JONAS_EJB_JAR_2_5_PUBLIC_ID` |
    `protected static java.lang.String` | `OLD_GENIC_CLASS_1` | Old GenIC class name (JOnAS 2.4.x).
    `protected static java.lang.String` | `OLD_GENIC_CLASS_2` | Old GenIC class name.
    `protected static java.lang.String` | `RMI_ORB` | RMI ORB.

    - ### Fields inherited from class org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool

      `ANALYZER_CLASS_FULL, ANALYZER_CLASS_SUPER, ANALYZER_FULL, ANALYZER_NONE, ANALYZER_SUPER, DEFAULT_ANALYZER, DEFAULT_BUFFER_SIZE, EJB_DD, JAR_COMPRESS_LEVEL, MANIFEST, META_DIR`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JonasDeploymentTool()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addVendorFiles​(java.util.Hashtable<java.lang.String,java.io.File> ejbFiles, java.lang.String ddPrefix)` | Add any vendor specific files which should be included in the EJB Jar.
    `protected void` | `checkConfiguration​(java.lang.String descriptorFileName, javax.xml.parsers.SAXParser saxParser)` | Verify the configuration.
    `protected java.lang.String` | `getJarBaseName​(java.lang.String descriptorFileName)` | Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file.
    `protected java.io.File` | `getVendorOutputJarFile​(java.lang.String baseName)` | .
    `void` | `processDescriptor​(java.lang.String aDescriptorName, javax.xml.parsers.SAXParser saxParser)` | Process a deployment descriptor, generating the necessary vendor specific deployment files.
    `protected void` | `registerKnownDTDs​(DescriptorHandler handler)` | Register the locations of all known DTDs.
    `void` | `setAdditionalargs​(java.lang.String aString)` | Sets the additional arguments.
    `void` | `setJarsuffix​(java.lang.String aString)` | Sets the jar suffix.
    `void` | `setJavac​(java.lang.String aString)` | Sets the java compiler to use.
    `void` | `setJavacopts​(java.lang.String aString)` | Set the options to pass to the java compiler.
    `void` | `setJonasroot​(java.io.File aFile)` | Set the JOnAS root directory.
    `void` | `setKeepgenerated​(boolean aBoolean)` | Sets the `keepgenerated` flag.
    `void` | `setKeepgeneric​(boolean aBoolean)` | Sets the `keepgeneric` flag.
    `void` | `setNocompil​(boolean aBoolean)` | Sets the `nocompil` flag.
    `void` | `setNogenic​(boolean aBoolean)` | Sets the `nogenic` flag.
    `void` | `setNovalidation​(boolean aBoolean)` | Sets the `novalidation` flag.
    `void` | `setOrb​(java.lang.String aString)` | Sets the `orb` to construct classpath.
    `void` | `setRmicopts​(java.lang.String aString)` | Set the options to pass to the rmi compiler.
    `void` | `setSecpropag​(boolean aBoolean)` | Sets the `secpropag` flag.
    `void` | `setVerbose​(boolean aBoolean)` | Sets the `verbose` flag.
    `protected void` | `writeJar​(java.lang.String baseName, java.io.File jarfile, java.util.Hashtable<java.lang.String,java.io.File> ejbFiles, java.lang.String publicId)` | Method used to encapsulate the writing of the JAR file.

    - ### Methods inherited from class org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool

      `addFileToJar, addSupportClasses, checkAndAddDependants, configure, createClasspath, getClassLoaderForBuild, getCombinedClasspath, getConfig, getDescriptorHandler, getDestDir, getLocation, getManifestFile, getPublicId, getTask, getVendorDDPrefix, log, needToRebuild, parseEjbFiles, setClasspath, setDestdir, setGenericJarSuffix, setTask, usingBaseJarName, validateConfigured`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EJB_JAR_1_1_PUBLIC_ID

          protected static final java.lang.String EJB_JAR_1_1_PUBLIC_ID

      Public Id of the standard deployment descriptor DTD.
      See Also:
        Constant Field Values

    - #### EJB_JAR_2_0_PUBLIC_ID

          protected static final java.lang.String EJB_JAR_2_0_PUBLIC_ID

      See Also:
        Constant Field Values

    - #### JONAS_EJB_JAR_2_4_PUBLIC_ID

          protected static final java.lang.String JONAS_EJB_JAR_2_4_PUBLIC_ID

      Public Id of the JOnAS-specific deployment descriptor DTD.
      See Also:
        Constant Field Values

    - #### JONAS_EJB_JAR_2_5_PUBLIC_ID

          protected static final java.lang.String JONAS_EJB_JAR_2_5_PUBLIC_ID

      See Also:
        Constant Field Values

    - #### RMI_ORB

          protected static final java.lang.String RMI_ORB

      RMI ORB.
      See Also:
        Constant Field Values

    - #### JEREMIE_ORB

          protected static final java.lang.String JEREMIE_ORB

      JEREMIE ORB.
      See Also:
        Constant Field Values

    - #### DAVID_ORB

          protected static final java.lang.String DAVID_ORB

      DAVID ORB.
      See Also:
        Constant Field Values

    - #### EJB_JAR_1_1_DTD

          protected static final java.lang.String EJB_JAR_1_1_DTD

      Name of the standard deployment descriptor DTD (these files are stored in the ${JONAS_ROOT}/xml directory).
      See Also:
        Constant Field Values

    - #### EJB_JAR_2_0_DTD

          protected static final java.lang.String EJB_JAR_2_0_DTD

      See Also:
        Constant Field Values

    - #### JONAS_EJB_JAR_2_4_DTD

          protected static final java.lang.String JONAS_EJB_JAR_2_4_DTD

      Name of the JOnAS-specific deployment descriptor DTD (these files are stored in the ${JONAS_ROOT}/xml directory).
      See Also:
        Constant Field Values

    - #### JONAS_EJB_JAR_2_5_DTD

          protected static final java.lang.String JONAS_EJB_JAR_2_5_DTD

      See Also:
        Constant Field Values

    - #### JONAS_DD

          protected static final java.lang.String JONAS_DD

      Default JOnAS deployment descriptor name.
      See Also:
        Constant Field Values

    - #### GENIC_CLASS

          protected static final java.lang.String GENIC_CLASS

      GenIC class name (JOnAS 2.5)
      See Also:
        Constant Field Values

    - #### OLD_GENIC_CLASS_1

          protected static final java.lang.String OLD_GENIC_CLASS_1

      Old GenIC class name (JOnAS 2.4.x).
      See Also:
        Constant Field Values

    - #### OLD_GENIC_CLASS_2

          protected static final java.lang.String OLD_GENIC_CLASS_2

      Old GenIC class name.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JonasDeploymentTool

          public JonasDeploymentTool()

  - ### Method Detail

    - #### setKeepgenerated

          public void setKeepgenerated​(boolean aBoolean)

      Sets the `keepgenerated` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setAdditionalargs

          public void setAdditionalargs​(java.lang.String aString)

      Sets the additional arguments.
      Parameters:
        `aString` - additional args.

    - #### setNocompil

          public void setNocompil​(boolean aBoolean)

      Sets the `nocompil` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setNovalidation

          public void setNovalidation​(boolean aBoolean)

      Sets the `novalidation` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setJavac

          public void setJavac​(java.lang.String aString)

      Sets the java compiler to use.
      Parameters:
        `aString` - the java compiler.

    - #### setJavacopts

          public void setJavacopts​(java.lang.String aString)

      Set the options to pass to the java compiler.
      Parameters:
        `aString` - the options.

    - #### setRmicopts

          public void setRmicopts​(java.lang.String aString)

      Set the options to pass to the rmi compiler.
      Parameters:
        `aString` - the options.

    - #### setSecpropag

          public void setSecpropag​(boolean aBoolean)

      Sets the `secpropag` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setVerbose

          public void setVerbose​(boolean aBoolean)

      Sets the `verbose` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setJonasroot

          public void setJonasroot​(java.io.File aFile)

      Set the JOnAS root directory.
      Parameters:
        `aFile` - the JOnAS root directory.

    - #### setKeepgeneric

          public void setKeepgeneric​(boolean aBoolean)

      Sets the `keepgeneric` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### setJarsuffix

          public void setJarsuffix​(java.lang.String aString)

      Sets the jar suffix.
      Parameters:
        `aString` - the string to use as the suffix.

    - #### setOrb

          public void setOrb​(java.lang.String aString)

      Sets the `orb` to construct classpath.
      Parameters:
        `aString` - 'RMI', 'JEREMIE', or 'DAVID'.

    - #### setNogenic

          public void setNogenic​(boolean aBoolean)

      Sets the `nogenic` flag.
      Parameters:
        `aBoolean` - `true` if the flag must be set.

    - #### processDescriptor

          public void processDescriptor​(java.lang.String aDescriptorName,
                                        javax.xml.parsers.SAXParser saxParser)

      Process a deployment descriptor, generating the necessary vendor specific deployment files...
      Specified by:
        `processDescriptor` in interface `EJBDeploymentTool`
      Overrides:
        `processDescriptor` in class `GenericDeploymentTool`
      Parameters:
        `aDescriptorName` - the name of the deployment descriptor
        `saxParser` - a SAX parser which can be used to parse the deployment descriptor.

    - #### writeJar

          protected void writeJar​(java.lang.String baseName,
                                  java.io.File jarfile,
                                  java.util.Hashtable<java.lang.String,java.io.File> ejbFiles,
                                  java.lang.String publicId)
                           throws BuildException

      Method used to encapsulate the writing of the JAR file. Iterates over the filenames/java.io.Files in the Hashtable stored on the instance variable ejbFiles..
      Overrides:
        `writeJar` in class `GenericDeploymentTool`
      Parameters:
        `baseName` - the base name to use.
        `jarfile` - the jar file to write to.
        `ejbFiles` - the files to write to the jar.
        `publicId` - the id to use.
      Throws:
        `BuildException` - if there is a problem.

    - #### addVendorFiles

          protected void addVendorFiles​(java.util.Hashtable<java.lang.String,java.io.File> ejbFiles,
                                        java.lang.String ddPrefix)

      Add any vendor specific files which should be included in the EJB Jar..
      Overrides:
        `addVendorFiles` in class `GenericDeploymentTool`
      Parameters:
        `ejbFiles` - a hashtable entryname -> file.
        `ddPrefix` - a prefix to use.

    - #### getVendorOutputJarFile

          protected java.io.File getVendorOutputJarFile​(java.lang.String baseName)

      .

    - #### getJarBaseName

          protected java.lang.String getJarBaseName​(java.lang.String descriptorFileName)

      Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file..
      Overrides:
        `getJarBaseName` in class `GenericDeploymentTool`
      Parameters:
        `descriptorFileName` - String representing the file name of an EJB descriptor to be processed
      Returns:
        The "basename" which will be used to name the completed JAR file

    - #### registerKnownDTDs

          protected void registerKnownDTDs​(DescriptorHandler handler)

      Register the locations of all known DTDs. vendor-specific subclasses should override this method to define the vendor-specific locations of the EJB DTDs.
      Overrides:
        `registerKnownDTDs` in class `GenericDeploymentTool`
      Parameters:
        `handler` - no used in this class.

    - #### checkConfiguration

          protected void checkConfiguration​(java.lang.String descriptorFileName,
                                            javax.xml.parsers.SAXParser saxParser)
                                     throws BuildException

      Verify the configuration.
      Overrides:
        `checkConfiguration` in class `GenericDeploymentTool`
      Parameters:
        `descriptorFileName` - the name of the descriptor file.
        `saxParser` - not used.
      Throws:
        `BuildException` - if there is an error.